(*
    ^CX^vύX <> 'Touchin.exe' (Sub.pas)
        Copyright (C) 1996,97,2004-06,08-11 IGJ-HMC, all rights reserved.
*)

unit Sub;

interface

uses
  Windows, SysUtils, StrUtils, Main;

type
  ESrcFileNotExist = class(EAppError);  // \[X݂Ȃ

const
  // Win9x n̕si2107-01-01 00:00:00 (UTC)j
  UnknownFileTime9x: TFileTime = (dwLowDateTime: $7F555800; dwHighDateTime: $0237499B);

  // WinNT n̕si1980-01-01 00:00:00 ([J)j
  UnknownFileTimeNT: TFileTime = (dwLowDateTime: $E1D58000; dwHighDateTime: $01A8E79F);

  // w\i2106-02-07 06:28:16 (UTC)j
  //  Win95/MeŊmFBtime_t 32rbgEɂ́B
  //  XPł́AFATȂ玩̂̐ł2107N܂ŁANTFSȂ10000NłB
  MaxFileTime: TFileTime = (dwLowDateTime: $D53E8000; dwHighDateTime: $0236485E);

const
  // Pb^^ԓ́Ab̒Pʐi^CX^v̍ŏPʂł100imbPʁj
  MicroSecondsPerSecond = 10 * 1000 * 1000;
  MicroSecondsPerMinute = MicroSecondsPerSecond * 60;
  MicroSecondsPerHour   = Int64(MicroSecondsPerMinute) * 60;

var
  UnknownFileTime: TFileTime;  // OSˑ̕s

function SetTimeStampProc(WildName: String; Option: TOption; TopLevel: Boolean = true; ExistFile: Boolean = false): Boolean;
function SystemTimeExToDiffTime(SystemTimeEx: TSystemTimeEx; out DiffTime: Int64): Boolean;


implementation

{ gVXet@C ϊ }
function SystemTimeExToFileTime(SystemTimeEx: TSystemTimeEx; out FileTime: TFileTime): Boolean;
var
  SystemTime: TSystemTime;
begin
  // bPbȏȂG[
  if SystemTimeEx.dwMicroSeconds >= MicroSecondsPerSecond then begin
    Result := false;
    Exit;
  end;

  // bȊOAPIŕϊ
  Move(SystemTimeEx, SystemTime, SizeOf(SystemTime));
  SystemTime.wMilliSeconds := 0;
  Result := SystemTimeToFileTime(SystemTime, FileTime);

  // bZ
  Inc(Int64(FileTime), SystemTimeEx.dwMicroSeconds);
end;

function FileTimeToSystemTimeEx(FileTime: TFileTime; out SystemTimeEx: TSystemTimeEx): Boolean;
var
  SystemTime: TSystemTime;
begin
  // APIŕϊA~b͎̂Ă
  Result := FileTimeToSystemTime(FileTime, SystemTime);
  Move(SystemTime, SystemTimeEx, SizeOf(SystemTime));

  // bvZ
  SystemTimeEx.dwMicroSeconds := Int64(FileTime) mod MicroSecondsPerSecond;
end;

{ t@C[J ϊ }
function FileTimeToLocalTimeEx(FileTime: TFileTime; out LocalTimeEx: TSystemTimeEx): Boolean;
var LocalFileTime: TFileTime;
begin
  Result := FileTimeToLocalFileTime(FileTime, LocalFileTime);
  Result := Result and FileTimeToSystemTimeEx(LocalFileTime, LocalTimeEx);
end;

function LocalTimeExToFileTime(LocalTimeEx: TSystemTimeEx; out FileTime: TFileTime): Boolean;
var LocalFileTime: TFileTime;
begin
  Result := SystemTimeExToFileTime(LocalTimeEx, LocalFileTime);
  Result := Result and LocalFileTimeToFileTime(LocalFileTime, FileTime);
end;

{ gVXeiԕ̂ݎgpjԍ ϊ }
function SystemTimeExToDiffTime(SystemTimeEx: TSystemTimeEx; out DiffTime: Int64): Boolean;
begin
  with SystemTimeEx do
    DiffTime :=
      Int64(wHour)   * MicroSecondsPerHour   +
      Int64(wMinute) * MicroSecondsPerMinute +
      Int64(wSecond) * MicroSecondsPerSecond +
      dwMicroSeconds;

  Result := true;
end;

function DiffTimeToSystemTimeEx(DiffTime: Int64; out SystemTimeEx: TSystemTimeEx): Boolean;
begin
  // ԒlFtO
  Result := (DiffTime < 0);
  if Result then DiffTime := -DiffTime;

  with SystemTimeEx do begin
    wHour := DiffTime div MicroSecondsPerHour;
    wMinute := (DiffTime div MicroSecondsPerMinute) mod 60;
    wSecond := (DiffTime div MicroSecondsPerSecond) mod 60;
    dwMicroSeconds := DiffTime mod MicroSecondsPerSecond;
  end;
end;

{ gVXe ϊ }
function SystemTimeExToStr(SystemTimeEx: TSystemTimeEx; FormatStr: String; MicroSecondsLength: Integer): String;
var p: Integer;
begin
  // ϊ
  with SystemTimeEx do
    Result := Format(FormatStr, [wYear, wMonth, wDay, wHour, wMinute, wSecond, dwMicroSeconds]);

  // b̌i܂X}[głȂ̂ŉƂcj
  p := AnsiPos('.', Result);
  if p = 0 then Exit;
  Delete(Result, p + MicroSecondsLength, 8 - MicroSecondsLength);
end;

{ s`FbN }
function IsUnknownFileTime(FileTime: TFileTime): Boolean;
begin
  Result := ((FileTime.dwLowDateTime or FileTime.dwHighDateTime) = 0) or
    (CompareFileTime(FileTime, UnknownFileTime) = 0);
end;

{ FAT^CX^vւ̊ۂ }
{ NTnŉȂƐ؂グŊۂ߂邽߁AOŏB}
{ FileTimeInt64֓@Ă݂AR[hTCY傫B}
procedure RoundToFATTime(FileName: String; DestStamp: TTimeStamp; var FileTime: TFileTime);

  // t@CVXe̎擾
  function GetFileSystemName: String;
  var
    FileSystemName: array[0..255] of Char;
    p: PChar;
    DmyDWORD: DWORD;
  begin
    // GetVolumeInformation ɂ́AhCu+'\' KvB
    //  JghCuł΁Anil ł悢B
    if ExtractFileDrive(FileName) = '' then begin
      p := nil;
    end
    else begin
      FileName := ExtractFileDrive(FileName) + '\';
      p := PChar(FileName);
    end;

    GetVolumeInformation(
      p,
      nil,
      0,
      nil,  // Ȃꂾvarł͂Ȃ
      DmyDWORD,
      DmyDWORD,
      FileSystemName,
      SizeOf(FileSystemName) );

    Result := FileSystemName;
  end;

var
  LocalTime: TSystemTimeEx;
  FileSystemName: String;
  IsExFAT: Boolean;

begin
  // FAT`FbN
  FileSystemName := GetFileSystemName;

  // FAT/FAT32i擪rj
  if AnsiStartsText('FAT', FileSystemName) then
    IsExFAT := false
  // exFAT
  else if FileSystemName = 'exFAT' then
    IsExFAT := true
  // ̑NTFSȂA^[
  else
    Exit;

  // [JɕϊĊۂ߂
  FileTimeToLocalTimeEx(FileTime, LocalTime);

  with LocalTime do begin
    case DestStamp of
      // XVFQbP
      tsWrite: begin
        wSecond := wSecond and (not 1);
        dwMicroSeconds := 0;
      end;

      // 쐬F10msP
      tsCreate:
        dwMicroSeconds := dwMicroSeconds div 100000 * 100000;

      // ANZXF͂ȂiexFAT͂QbPʁj
      tsAccess: begin
        if IsExFAT then begin
          wSecond := wSecond and (not 1);
        end
        else begin
          wHour := 0;  wMinute := 0;  wSecond := 0;
        end;

        dwMicroSeconds := 0;
      end;
    end;
  end;

  // t@Cɖ߂
  LocalTimeExToFileTime(LocalTime, FileTime);
end;

{ ^CX^vύX }
procedure SetFileTime(FileName: String; Option: TOption; IsDirectory: Boolean);
var
  MicroSecondsLength: Integer;

  // ^CX^vύXiWin9x fBNgj
  function SetDirectoryTime9x(DirName: String; FileTime: TFileTime; DestStamp: TTimeStamp): Boolean;
  const
    ActionNumber: array[TTimeStamp] of Integer = (3, 7, 5);  // int 21h-7143h p

  var
    DosDate, DosTime, MSecond: WORD;
    LocalFileTime: TFileTime;
    SystemTime: TSystemTime;
    Command: String;
    SI: TStartupInfo;
    PI: TProcessInformation;

  begin
    // t@CDOSt@Cϊ
    FileTimeToLocalFileTime(FileTime, LocalFileTime);

    if FileTimeToDosDateTime(LocalFileTime, DosDate, DosTime) then begin
      // DosTime̕b͂PrbgEVtĝȂ̂ŁAbł΃~b1000Zi0`1999 ͈̔́j
      FileTimeToSystemTime(FileTime, SystemTime);
      MSecond := SystemTime.wMilliSeconds;
      if Odd(SystemTime.wSecond) then Inc(MSecond, 1000);
    end
    else begin
      // slȂAׂĂO
      DosDate := 0;
      DosTime := 0;
      MSecond := 0;
    end;

    // R}hC쐬
    //  TouchDir.exe ̓pXȂŎw肵ĂApXɃOt@C܂܂ĂƓ삹B
    //  šʁAV[gt@CŃtpXw肷Γ삷悤ɂȂB
    Command := ExtractShortPathName(ExtractFilePath(ParamStr(0)) + 'TouchDir.exe ') +
      Format('"%s" %d %x %x %x', [DirName, ActionNumber[DestStamp], DosDate, DosTime, MSecond div 10]);

    // vZX̎s
    FillChar(SI, SizeOf(SI), 0);
    SI.cb := SizeOf(SI);
    SI.dwFlags := STARTF_USESHOWWINDOW;
//  SI.wShowWindow := SW_HIDE;  // R\[炾ƖӖH
    Result := CreateProcess(nil, PChar(Command), nil, nil, false, 0, nil, nil, SI, PI);

    while WaitForSingleObject(PI.hProcess, 0) = WAIT_TIMEOUT do { Nop };
    CloseHandle(PI.hThread);
    CloseHandle(PI.hProcess);
  end;

  // t@C̃^CX^v擾
  function GetFileTime(FileName: String; SrcStamp: TSrcStamp; out MatchedName: String): TFileTime; overload;
  var
    FindHandle: THandle;
    FindData: TWin32FindData;
  begin
    FindHandle := FindFirstFile(PChar(FileName), FindData);

    if FindHandle = INVALID_HANDLE_VALUE then
      raise EAppError.Create('t@C (' + FileName + ') ܂');

    with FindData do begin
      // ChJ[hw莞pɁA}b`t@CԂ
      MatchedName := String(cFileName);

      case SrcStamp of
        tsWrite:   Result := ftLastWriteTime;
        tsCreate:  Result := ftCreationTime;
        tsAccess:  Result := ftLastAccessTime;
      end;
    end;

    Windows.FindClose(FindHandle);
  end;

  function GetFileTime(FileName: String; SrcStamp: TSrcStamp): TFileTime; overload;
  var
    DmyString: String;
  begin
    Result := GetFileTime(FileName, SrcStamp, DmyString);
  end;

  // ݒ肷^CX^v̎Zo
  function NewFileTime(FileName: String; SrcStamp: TSrcStamp): TFileTime;
  var
    FileTime: TFileTime;
    LocalTime: TSystemTimeEx;
    MatchedName: String;
    ErrTime: Boolean;

  begin
    // slŏ
    Result.dwLowDateTime  := 0;
    Result.dwHighDateTime := 0;

    // slwȂA^[
    if Option.ModifyTime = mtUnknown then Exit;

    // ݓ
    if Option.SrcStamp = tsNow then begin
      FileTime := NowFileTime;
    end
    // \[Xw
    else begin
      // \[Xt@C̎w肪΁Agp
      if Option.SrcFileName <> '' then begin
        // tH_̓t@C
        if AnsiLastChar(Option.SrcFileName)^ in ['\', ':'] then begin
          try
            FileName := ExtractFilePath(Option.SrcFileName) + ExtractRelativePath(Option.WildName, FileName);
            FileTime := GetFileTime(FileName, SrcStamp);
          except
            raise ESrcFileNotExist.Create('');
          end;
        end
        // t@Cw
        else begin
          FileTime := GetFileTime(Option.SrcFileName, SrcStamp, MatchedName);
          Option.SrcFileName := ExtractFilePath(Option.SrcFileName) + MatchedName;
        end;
      end
      // Ȃ΂̂܂܁ig\[XƂj
      else begin
        FileTime := GetFileTime(FileName, SrcStamp);
      end;

      // slȂA^[
      if IsUnknownFileTime(FileTime) then Exit;
    end;

    // <IvV -d, -t ̐ݒ𔽉f>
    // t@C[Jϊ
    FileTimeToLocalTimeEx(FileTime, LocalTime);

    // IvVݒ肩Rs[
    case Option.ModifyTime of
      // twiׂăRs[A\[Xw͖Ӗj
      mtDate:
        LocalTime := Option.SetTime;

      // ̑w肠iw荀ڂRs[j
      mtTime..mtDateMonth:
        with LocalTime do begin
          wHour   := Option.SetTime.wHour;
          wMinute := Option.SetTime.wMinute;
          wSecond := Option.SetTime.wSecond;
          dwMicroSeconds := Option.SetTime.dwMicroSeconds;

          if Option.ModifyTime in [mtDateDay, mtDateMonth] then wDay := Option.SetTime.wDay;
          if Option.ModifyTime = mtDateMonth then wMonth := Option.SetTime.wMonth;
        end;
    end;

    // t@Cɖ߂
    ErrTime := not LocalTimeExToFileTime(LocalTime, FileTime);

    // ΎwlZ
    Inc(Int64(FileTime), Option.DiffTime);

    // ͈̓`FbN
    if (LocalTime.wYear < 1980) or (CompareFileTime(FileTime, MaxFileTime) >= 0) then
      ErrTime := true;

    if ErrTime then
      raise EAppError.Create('̎wɌ肪܂');

    Result := FileTime;
  end;

  // \[X^CX^vʂ̎擾
  function GetSrcStamp(DestStamp: TTimeStamp): TSrcStamp;
  begin
    // ݒȂAfXeBl[Vʂgp
    if Option.SrcStamp = tsSame then
      Result := DestStamp
    else
      Result := Option.SrcStamp;
  end;

  // ^CX^vpX|Xt@C̍쐬
  procedure MakeRestoreTimeStampFile;
  const
    StampOption: array[TTimeStamp] of Char = ('w', 'c', 'a');
  var
    FileTime: TFileTime;
    LocalTime: TSystemTimeEx;
    DestStamp: TTimeStamp;
    Command, QuotedFileName: String;
    HasDelimiter: Boolean;
  begin
    // ŏ̏
    if DispFirstInfo then begin
      DispFirstInfo := false;
      Writeln(ErrOutput, CrLf + '^CX^vݒ쐬܂B');
    end;

    // vr[ȂAt@C\ă^[
    if Option.Preview then begin
      Writeln('쐬܂B(', FileName, ')');
      Exit;
    end;

    // ؂蕶܂ł邩
    HasDelimiter := (AnsiPos(';', FileName) > 0);

    // NI[gttpX쐬
    QuotedFileName := ExpandFileName(FileName);
    if Pos(' ', QuotedFileName) > 0 then QuotedFileName := '"' + QuotedFileName + '"';

    // R}hC쐬Ao
    for DestStamp := Low(TTimeStamp) to High(TTimeStamp) do begin
      if (DestStamp in Option.DestStamps) = false then Continue;

      // IvV
      Command := '-ixg' + StampOption[DestStamp] + ' ';
      if HasDelimiter then Command := Command + '-zd0 ';

      FileTime := GetFileTime(FileName, DestStamp);

      // ^CX^vs
      if IsUnknownFileTime(FileTime) then begin
        Command := Command + '-d:unknown' + StringOfChar(' ', 16 + MicroSecondsLength);
      end
      // ʏ^CX^v
      else begin
        FileTimeToLocalTimeEx(FileTime, LocalTime);
        Command := Command + SystemTimeExToStr(LocalTime, '-d:%d-%.2d-%.2d -t:%.2d:%.2d:%.2d.%.7d ', MicroSecondsLength);
      end;

      Writeln(Command, QuotedFileName);
    end;

    // t@C\
    Writeln(ErrOutput, '쐬܂B(', FileName, ')');
  end;

const
  StampName: array[TTimeStamp] of String = ('XV', '쐬', 'ANZX');

var
  FileTime: array[TTimeStamp] of TFileTime;
  FileTimePtr: array[TTimeStamp] of PFileTime;
  LocalTime: array[TTimeStamp] of TSystemTimeEx;
  PrevFileTime: array[TTimeStamp] of TFileTime;
  FileSetTime: TFileTime;
  Handle: THandle;
  Changed: Boolean;
  Status: (stChanged, stCantChanged, stSrcFileNotExist, stScheduled);
  Message: String;
  FlagsAndAttributes: DWORD;
  DestStamp: TTimeStamp;
  ST: TSystemTimeEx;
  s: String;

begin
  // b\
  if Option2.MicroSecondsDigits = 0 then
    MicroSecondsLength := 0
  else
    MicroSecondsLength := Option2.MicroSecondsDigits + 1;

  // ^CX^vpX|Xt@C̍쐬
  if Option.MakeResp then begin
    MakeRestoreTimeStampFile;
    Exit;
  end;

  try
    // ^CX^vʂƂ̕\l쐬
    for DestStamp := Low(TTimeStamp) to High(TTimeStamp) do begin
      // ݂̃^CX^v^CX^vƂĕۑ
      // iANZXێpɎgp̂ŁAύXw肪邩ǂɂ炸A擾͍sj
      PrevFileTime[DestStamp] := GetFileTime(FileName, DestStamp);

      // ύXw肪ȂʂȂ΁Ã[v
      if (DestStamp in Option.DestStamps) = false then Continue;

      // V^CX^v̎Zo
      //  slȂÂ܂ܐݒ肷邱Ƃ͂łȂ̂ŁAȂ̒lɂ
      FileSetTime := NewFileTime(FileName, GetSrcStamp(DestStamp));
      if (FileSetTime.dwHighDateTime or FileSetTime.dwLowDateTime) = 0 then FileSetTime := UnknownFileTime;

      FileTime[DestStamp] := FileSetTime;

      // [Jɕϊ
      if Option.ModifyTime <> mtUnknown then begin
        if Option2.RoundTime then RoundToFATTime(FileName, DestStamp, FileTime[DestStamp]);
        FileTimeToLocalTimeEx(FileTime[DestStamp], LocalTime[DestStamp]);
      end;
    end;

    // vr[
    if Option.Preview then begin
      Status := stScheduled;
    end
    // ʏ폈
    else begin
      // fBNgiWin9xj
      if IsDirectory and (IsWinNT = false) then begin
        Changed := true;

        for DestStamp := Low(TTimeStamp) to High(TTimeStamp) do begin
          if DestStamp in Option.DestStamps then
            Changed := Changed and SetDirectoryTime9x(FileName, FileTime[DestStamp], DestStamp);
        end;
      end
      // t@C^fBNgiWinNTj
      else begin
        // NTfBNgύXptO
        if IsDirectory then
          FlagsAndAttributes := FILE_FLAG_BACKUP_SEMANTICS
        else
          FlagsAndAttributes := FILE_ATTRIBUTE_NORMAL;

        // ύX
        Handle := CreateFile(PChar(FileName), GENERIC_WRITE, 0, nil, OPEN_EXISTING, FlagsAndAttributes, 0);

        if Handle <> INVALID_HANDLE_VALUE then begin
          for DestStamp := Low(TTimeStamp) to High(TTimeStamp) do begin
            // ύXw肠̂Ƃ
            if DestStamp in Option.DestStamps then begin
              FileTimePtr[DestStamp] := @(FileTime[DestStamp]);
            end
            // ύXwȂ̂Ƃ
            else begin
              // ANZX́Aw肪ȂĂlĐݒ肵ĕێiݒ肵ȂƌݓɍXVĂ܂j
              if DestStamp = tsAccess then
                FileTimePtr[DestStamp] := @(PrevFileTime[DestStamp])
              else
                FileTimePtr[DestStamp] := nil;
            end;
          end;

          // ύXs
          Changed := Windows.SetFileTime(Handle, FileTimePtr[tsCreate], FileTimePtr[tsAccess], FileTimePtr[tsWrite]);
          CloseHandle(Handle);
        end
        else begin
          // JȂĂAύXłȂƂ
          Changed := false;
        end;
      end;

      if Changed then Status := stChanged else Status := stCantChanged;
    end;

  except
    on ESrcFileNotExist do Status := stSrcFileNotExist;
  end;

  // ŏ̏
  if DispFirstInfo then begin
    DispFirstInfo := false;
    Writeln;

    // ^CX^vʂƂɕ\
    for DestStamp := Low(TTimeStamp) to High(TTimeStamp) do begin
      if (DestStamp in Option.DestStamps) = false then Continue;

      // slw
      if (Option.SrcStamp = tsNow) and IsUnknownFileTime(FileTime[DestStamp]) then begin
        Message := 'sɕύX';
      end
      else begin
        // ݓ^wi\[Xw͖Ӗj
        if (Option.SrcStamp = tsNow) or (Option.ModifyTime = mtDate) then begin
          Message := '%d-%.2d-%.2d %.2d:%.2d:%.2d ɕύX';
        end
        // \[Xw
        else begin
          // t@Cw肠
          if Option.SrcFileName <> '' then
            Message := '''' + Option.SrcFileName + ''' '
          // wȂ
          else
            Message := '';

          Message := Message + StampName[GetSrcStamp(DestStamp)] + 'Rs[';

          if not IsUnknownFileTime(FileTime[DestStamp]) then begin
            case Option.ModifyTime of
              mtTime:
                Message := Message + 'A %3:.2d:%4:.2d:%5:.2d ɕύX';
              mtDateDay:
                Message := Message + 'A %2:.2d %3:.2d:%4:.2d:%5:.2d ɕύX';
              mtDateMonth:
                Message := Message + 'A %1:.2d-%2:.2d %3:.2d:%4:.2d:%5:.2d ɕύX';
              mtNone:
                if Option.DiffTime <> 0 then begin
                  if DiffTimeToSystemTimeEx(Option.DiffTime, ST) then s := '-' else s := '+';
                  with ST do Message := Message + Format('A %s%d:%.2d:%.2d ', [s, wHour, wMinute, wSecond]);
                end;
            end;
          end;
        end;

        Message := SystemTimeExToStr(LocalTime[DestStamp], Message, 8{b\͂Ȃ̂ō폜svA폜Ɗgqt@C̎Ȃ});
      end;

      Writeln(StampName[DestStamp], ' ', Message, '܂B');
    end;
  end;

  // t@CƂ̃Xe[^X
  case Status of
    stChanged:         Write('ύX܂');
    stCantChanged:     Write('Warn.: ύXł܂ł');
    stSrcFileNotExist: Write('Warn.: Rs[t@C܂');
    stScheduled:       Write('ύX܂');
  end;

  Writeln('B(', FileName, ')');

  // vr[ڍ
  if Status = stScheduled then begin
    for DestStamp := Low(TTimeStamp) to High(TTimeStamp) do begin
      if (DestStamp in Option.DestStamps) = false then Continue;

      // ύX
      if IsUnknownFileTime(FileTime[DestStamp]) then
        Message := '          s'
      else
        Message := SystemTimeExToStr(LocalTime[DestStamp], '%d-%.2d-%.2d %.2d:%.2d:%.2d.%.7d', MicroSecondsLength);

      // ύXO
      if IsUnknownFileTime(PrevFileTime[DestStamp]) then begin
        Message := '          s' + StringOfChar(' ', 6 + MicroSecondsLength) + ' ' + Message;
      end
      else begin
        FileTimeToLocalTimeEx(PrevFileTime[DestStamp], LocalTime[DestStamp]);
        Message := SystemTimeExToStr(LocalTime[DestStamp], '%d-%.2d-%.2d %.2d:%.2d:%.2d.%.7d  ' + Message, MicroSecondsLength);
      end;

      Writeln(Format('%10.8s: ', [StampName[DestStamp]]), Message);
    end;
  end;
end;

{ ^CX^vύX }
function SetTimeStampProc(WildName: String; Option: TOption; TopLevel: Boolean = true; ExistFile: Boolean = false): Boolean;

  // fBNg̃`FbN
  function IsDirectory(FindData: TWin32FindData): Boolean;
  begin
    Result := LongBool(FindData.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY);
  end;

var
  FileName, FilePath: String;
  FindHandle: THandle;
  FindData: TWin32FindData;

begin
  // ŏʃxȂ΁AbZ[W\
  if TopLevel then DispFirstInfo := true;

  FilePath := ExtractFilePath(WildName);

  // t@C
  FindHandle := FindFirstFile(PChar(WildName), FindData);
  if FindHandle <> INVALID_HANDLE_VALUE then begin
    repeat
      FileName := FilePath + String(FindData.cFileName);

      // sIhŏIt@CifBNg '.', '..' ܂ށj́AύXɎŝŖ
      if AnsiLastChar(FileName)^ = '.' then Continue;

      // fBNgȂ΁c
      if IsDirectory(FindData) then begin
        // ڎwiTutH_w肪ȂAChJ[hȂjȂ΁AuׂẴtH_ΏہvȊOłΕύX
        if (Option.SubDir = false) and (AnsiCompareText(FindData.cFileName, ExtractFileName(WildName)) = 0) then begin
          if Option.TouchDir = tdAll then Continue;
        end
        else begin
          //u}b`tH_݂̂Ώہ^t@CȂvȂ΁AύX
          //  ȊOȂΕύXȂiuׂẴtH_ΏہvɂẮAfBNgŕύXj
          if Option.TouchDir in [tdNone, tdAll] then Continue;
        end;
      end
      // t@CȂ΁Aut@CȂvȊOłΕύX
      else begin
        if Option.TouchDir = tdDirOnly then Continue;
      end;

      ExistFile := true;
      SetFileTime(FileName, Option, IsDirectory(FindData));  // Not API
    until FindNextFile(FindHandle, FindData) = false;

    Windows.FindClose(FindHandle);
  end;

  // fBNg
  if Option.SubDir or (Option.TouchDir = tdAll) then begin
    FindHandle := FindFirstFile(PChar(FilePath + '*'), FindData);
    if FindHandle <> INVALID_HANDLE_VALUE then begin
      repeat
        // '.', '..' ȊÕfBNgȂ΁c
        if IsDirectory(FindData) and (AnsiLastChar(FindData.cFileName)^ <> '.') then begin
          FileName := FilePath + String(FindData.cFileName);

          //uׂẴtH_Ώہv̏
          if Option.TouchDir = tdAll then begin
            ExistFile := true;
            SetFileTime(FileName, Option, true);  // Not API
          end;

          // TufBNǧiċAj
          if Option.SubDir then
            ExistFile := SetTimeStampProc(FileName + '\' + ExtractFileName(WildName), Option, false, ExistFile);
        end;
      until FindNextFile(FindHandle, FindData) = false;

      Windows.FindClose(FindHandle);
    end;
  end;

  Result := ExistFile;
end;

end.

